#include "mach/../../cci_smem.h"
#include "mach/../../smd_private.h"
//#include <mach/msm_battery.h>
//cci_smem_value_t *smem_cci_smem_value;
//hw_type
//g_lcd_type

// MDDI interface
#include "msm_fb.h"
#include "mddihost.h"
#include "mddihosti.h"

#ifndef CONFIG_FB_MSM_MDDI
#define CONFIG_FB_MSM_MDDI
#endif

#ifdef CONFIG_FB_MSM_MDDI

//#include <asm/gpio.h>
#include <mach/gpio.h>
#include <mach/msm_rpcrouter.h>
#include <mach/vreg.h>
#include <mach/mpp.h>
#include <linux/leds.h>
#include <linux/mutex.h>
#include <linux/i2c.h>
#include <linux/workqueue.h> 
#include <linux/interrupt.h> 
#include <linux/irq.h> 
#include <linux/kernel.h>
#include <linux/module.h>

#include <linux/proc_fs.h>//added by steve@cci for acer CR tuning

#define CCI_AB60_HVGA_PRIM 	1
#define LCD_BLK_EN 		32
#define LCD_RST_N 		89
#define LCD_ID0  			20
#define LCD_RST_N_113 113
#define LCD_2nd_SOURCE 108

#define START_DISABLE_HIBERNATION 0
#define STOP_DISABLE_HIBERNATION 1
#define DISABLE_HIBERNATION_THRESHOLD 200

#define BLK_UI_MAX_VAL	255
#define BLK_UI_MIN_VAL	30
#define BLK_LEVEL_NUM	5


typedef enum 
{
   	LCD_TYPE_AUO = 0,
  	LCD_TYPE_TPO,
  	LCD_TYPE_INVALID = 0xFF
} E_LCD_TYPE;

#define ENABLE_DEBUG 		0
#define ENABLE_DEBUG_FUNCTION 	0
#define TPO_DISABLE_HIBERNATION_FUNCTION	1

#if ENABLE_DEBUG
	#define MSG_DBG(format,args...) do { \
				printk(KERN_INFO "[LCD] %s():%d: " format, __func__, __LINE__, ##args); \
			} while(0)
	#define MSG_ERR(format,args...) do { \
				printk(KERN_ERR "[LCD][ERROR] %s():%d: " format, __func__, __LINE__, ##args); \
			} while(0)			
#if ENABLE_DEBUG_FUNCTION
	#define MSG_FUN_ENTER	printk(KERN_INFO "[LCD] %s()+: %d\r\n", __func__, __LINE__)
	#define MSG_FUN_EXIT	printk(KERN_INFO "[LCD] %s()-: %d\r\n", __func__, __LINE__)
#else
	#define MSG_FUN_ENTER	do { } while(0)
	#define MSG_FUN_EXIT	do { } while(0)
#endif

#else
	#define MSG_DBG(format,args...) do { } while(0)
	#define MSG_ERR(format,args...) do { \
				printk(KERN_ERR "[LCD][ERROR] %s():%d: " format, __func__, __LINE__, ##args); \
			} while(0)	
	#define MSG_FUN_ENTER	do { } while(0)
	#define MSG_FUN_EXIT	do { } while(0)		
#endif



static int panel_type_number = -1;
module_param_named( panel_type, panel_type_number, int, S_IRUGO | S_IWUSR | S_IWGRP);

/*******************************************************************************
 * * Local Variable Declaration
 * *******************************************************************************/
static uint32 mddi_cci_ab60_rows_per_second = 13830;	// 5200000/376
static uint32 mddi_cci_ab60_rows_per_refresh = 338;
static uint32 mddi_cci_ab60_usecs_per_refresh = 24440;	// (376+338)/5200000
static boolean mddi_cci_ab60_debug_60hz_refresh = FALSE;

//steve added for make sure backlight function is called after LCM is updated
boolean first_backlight = FALSE;
boolean backlight_return = FALSE;
int backlight_value;
boolean update = FALSE;
//steve added for make sure backlight function is called after LCM is updated

//static int backlight_val = 128;
//E_LCD_TYPE g_lcd_type = LCD_TYPE_INVALID;
//static cci_hw_id_type hw_type = HW_ID_EMU;
#if TPO_DISABLE_HIBERNATION_FUNCTION
static boolean g_disable_hibernation_state = FALSE;
#endif
static boolean blk_on_timer_initialized = FALSE;
boolean LCD_powered = TRUE;
boolean First_bootup = TRUE;

//added by steve@cci for Bug341
static uint32 blk_value_before_display_on = 0;

static unsigned char blk_ui_range[BLK_LEVEL_NUM];
//static unsigned char other_blk_val_transform_table[BLK_LEVEL_NUM] =  { 30, 55, 90, 165, 255 };
//static unsigned char auo_blk_val_transform_table_dvt2[BLK_LEVEL_NUM] =  { 30, 55, 90, 165, 255 };
//static unsigned char auo_blk_val_transform_table_pvt[BLK_LEVEL_NUM]  =  {  5, 22, 50, 135, 255 };
//static unsigned char tpo_blk_val_transform_table_dvt2[BLK_LEVEL_NUM] =  { 30, 70, 105, 180, 255 };
static unsigned char tpo_blk_val_transform_table_pvt[BLK_LEVEL_NUM]  =  { 5, 30, 65, 130, 255 };
static bool b_blk_transform_init = FALSE;
static unsigned char *p_blk_val_transform;

struct timer_list tpo_update_timer;
struct timer_list blk_on_timer;
static DECLARE_MUTEX(tpo_timer_mutex);
static DECLARE_MUTEX(blk_on_timer_mutex);
static void lcd_power_off_sequence(void);

/*******************************************************************************
 * * Local Function Declaration
 * *******************************************************************************/
static void mddi_cci_ab60_prim_lcd_init(void);
static void mddi_cci_ab60_lcd_set_backlight(struct msm_fb_data_type *mfd);
static struct msm_panel_common_pdata *mddi_cci_ab60_pdata;
//#define mddih_host_data_packet_size_type int
//#define MDDI_DATA_PACKET_SIZE_4_BYTES 1
boolean write_client_reg_TPO(uint32 reg_addr,uint8 *reg_Value, mddih_host_data_packet_size_type reg_packet_size, boolean wait);

void mddi_cci_ab60_set_backlight_level(int value);
static void lcd_power_on_init(void);
//static void set_lcd_backlight(struct led_classdev *led_dev, enum led_brightness value);

//added by steve@cci for acer CR tuning
static int proc_lcm_CR_read(char *page, char**start, off_t offset, int count, int *eof, void *data);
static int proc_lcm_CR_write(struct file *file, const char *buffer, unsigned long count, void *data);

/*******************************************************************************
 * * External Variable Declaration
 * *******************************************************************************/
extern uint32 mddi_host_core_version;
extern struct proc_dir_entry proc_root;  //added by steve@cci for acer CR tuning
/*******************************************************************************
 * * External Function Declaration
 * *******************************************************************************/

/* /proc/lcmCR */
static struct proc_dir_entry *lcmCR_proc_dir = NULL; //added by steve@cci for acer CR tuning

void blk_value_transform_init(void)
{
	int i, blk_ui_gap;

	blk_ui_range[0] = BLK_UI_MIN_VAL;
	blk_ui_range[BLK_LEVEL_NUM-1] = BLK_UI_MAX_VAL;

	blk_ui_gap = (BLK_UI_MAX_VAL - BLK_UI_MIN_VAL)/(BLK_LEVEL_NUM-1);		
	for(i=1; i<(BLK_LEVEL_NUM-1); i++ )
		blk_ui_range[i] = blk_ui_range[i-1] + blk_ui_gap;
/*
	if( hw_type > HW_ID_DVT2 )
	{
		switch( g_lcd_type )
		{
			case LCD_TYPE_TPO:
				MSG_DBG("[BLK][PVT][TPO]\n");
				p_blk_val_transform = tpo_blk_val_transform_table_pvt;
				break;
			case LCD_TYPE_AUO:
				MSG_DBG("[BLK][PVT][AUO]\n");
				p_blk_val_transform = auo_blk_val_transform_table_pvt;
				break;	
			default:
				MSG_ERR("[BLK][PVT]LCD type: INVALID!\n");
				p_blk_val_transform = other_blk_val_transform_table;
				break;
		}		
	}
	else
	{
		switch( g_lcd_type )
		{
			case LCD_TYPE_TPO:
				MSG_DBG("[BLK][TPO]\n");
				p_blk_val_transform = tpo_blk_val_transform_table_dvt2;
				break;
			case LCD_TYPE_AUO:
				MSG_DBG("[BLK][AUO]\n");
				p_blk_val_transform = auo_blk_val_transform_table_dvt2;
				break;	
			default:
				MSG_ERR("[BLK]LCD type: INVALID!\n");
				p_blk_val_transform = other_blk_val_transform_table;
				break;
		}			
	}			
	*/
	
	MSG_DBG("[BLK][PVT][TPO]\n");
	p_blk_val_transform = tpo_blk_val_transform_table_pvt;

	b_blk_transform_init = TRUE;
}

unsigned char blk_value_transform(unsigned char ui_val)
{
	int i;
	unsigned char transform_val = 0;
	
	if(!b_blk_transform_init)
		blk_value_transform_init();

	if( ui_val <= blk_ui_range[0] )
		transform_val = *p_blk_val_transform;
	else if( ui_val >= blk_ui_range[BLK_LEVEL_NUM-1] )
		transform_val = *(p_blk_val_transform + BLK_LEVEL_NUM-1);
	else
	{
		for(i=0; i<(BLK_LEVEL_NUM-1); i++ )
			if( ui_val > blk_ui_range[i] && ui_val <= blk_ui_range[i+1] )
			{
				transform_val = ( *(p_blk_val_transform +i +1 ) - *(p_blk_val_transform +i) ) * (ui_val-blk_ui_range[i]) / (blk_ui_range[i+1] - blk_ui_range[i]) + *(p_blk_val_transform +i);
				break;
			}
	}
	return transform_val;
}

void backlight_on( boolean bEnable )
{
	if(bEnable)
	{
		//MSG_DBG("John Backlight on!\r\n");
		//gpio_direction_output(LCD_BLK_EN,1);
	}
	else
	{
		//MSG_DBG("John Backlight off!\r\n");
		//gpio_direction_output(LCD_BLK_EN,0);
	}
}

void blk_on_timer_handler(unsigned long data)
{
	MSG_FUN_ENTER;

	blk_on_timer_initialized = FALSE;

	if( LCD_powered )
		backlight_on(TRUE);

	MSG_FUN_EXIT;	
}

void blk_on_proc(void)
{
	down(&blk_on_timer_mutex);

	if( !blk_on_timer_initialized )
	{
		init_timer(&blk_on_timer);
		blk_on_timer.function = blk_on_timer_handler;
		blk_on_timer.expires = jiffies + (HZ/100 * 30);		
		add_timer(&blk_on_timer);	
		blk_on_timer_initialized = TRUE;
	}	
	else
	{
		blk_on_timer.function = blk_on_timer_handler;
		mod_timer(&blk_on_timer, jiffies + (HZ/100 * 30));
	}

	up(&blk_on_timer_mutex);
}

#if TPO_DISABLE_HIBERNATION_FUNCTION
void disable_hibernation_timer_handler(unsigned long data)
{
	boolean bEnable = (boolean)data;
	
	MSG_FUN_ENTER;
	
	if( bEnable )
	{
		if (!g_disable_hibernation_state )
		{
			mddi_host_disable_hibernation(TRUE);
			g_disable_hibernation_state = TRUE;
		}
		tpo_update_timer.data = FALSE;
		mod_timer(&tpo_update_timer, jiffies + (HZ*2));				
	}
	else
	{
		if ( g_disable_hibernation_state )
		{
			mddi_host_disable_hibernation(FALSE);

			g_disable_hibernation_state = FALSE;
		}
	}
	
	MSG_FUN_EXIT;	
}
#endif

void disable_hibernation_proc(boolean bEnable)
{
#if TPO_DISABLE_HIBERNATION_FUNCTION
/*
	static bool timer_init = FALSE;

	if( hw_type >= HW_ID_PVT )
		return;
		
	if( bEnable && backlight_val < DISABLE_HIBERNATION_THRESHOLD  )
		return;
	
	if( !timer_init )
	{
		init_timer(&tpo_update_timer);
		tpo_update_timer.function = disable_hibernation_timer_handler;
		tpo_update_timer.data = (unsigned long)bEnable;
		tpo_update_timer.expires = jiffies + (HZ/1000);
		add_timer(&tpo_update_timer);	
		timer_init = TRUE;
	}
	else
	{
		tpo_update_timer.data = (unsigned long)bEnable;
		mod_timer(&tpo_update_timer, jiffies + (HZ/1000));
	}
*/
#endif
}
void update_backlight_to_battery(int value)
{
/*
    cci_batt_device_status_update(0xE0,0);
    if (value >= 235)
        cci_batt_device_status_update(CCI_BATT_DEVICE_ON_LCD_BACKLIGHT_150,1);
    else if (value >= 145)
        cci_batt_device_status_update(CCI_BATT_DEVICE_ON_LCD_BACKLIGHT_100,1);
    else if (value >= 30)
        cci_batt_device_status_update(CCI_BATT_DEVICE_ON_LCD_BACKLIGHT_50,1);
*/
}
void mddi_cci_ab60_set_backlight_level(int value)
{
	uint32  RegPrm[4];
    int err = 0;
	cci_smem_value_t *smem_cci_smem_value = 0;

    MSG_FUN_ENTER;

    memset(RegPrm,0,sizeof(RegPrm));

    printk(KERN_INFO "[backlight] want the blk value=%d\r\n", value);
	if ( !LCD_powered )
	{
        blk_value_before_display_on = value;//added by steve@cci for Bug341
        return;
    }
    if(first_backlight || !update)
    {
        backlight_value = value;
        first_backlight = FALSE;
        backlight_return = TRUE;
        printk(KERN_INFO"[backlight] not update frame yet, return.\n");
        return;
    }
    //C4: infor backlihgt level to battery driver
    //update_backlight_to_battery(value);

    smem_cci_smem_value = smem_alloc( SMEM_CCI_SMEM_VALUE, sizeof( cci_smem_value_t ) );
    switch(smem_cci_smem_value->cci_hw_id)
    {
        case HW_ID_EVT0:
        case HW_ID_DVT1:
        case HW_ID_DVT1_2:
        case HW_ID_DVT2:
        case HW_ID_DVT2_2:
            RegPrm[0] = 0x2c;//0x24;
            err = mddi_host_register_multiwrite(0x0053, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = value;
            err = mddi_host_register_multiwrite(0x0051, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            break;
        case HW_ID_PVT:
        default:
            if(gpio_get_value(LCD_2nd_SOURCE))
			{
                RegPrm[0] = 0x01;
                RegPrm[1] = value;
                RegPrm[2] = 0x07;//pwm 5kHz
                RegPrm[3] = 0x09;//08;
                err = mddi_host_register_multiwrite(0x00b9, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
                if(err)
                    printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            }else{
                RegPrm[0] = 0x2c;//0x24;
                err = mddi_host_register_multiwrite(0x0053, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
                if(err)
                    printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

                RegPrm[0] = value;
                err = mddi_host_register_multiwrite(0x0051, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
                if(err)
                    printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            }
            break;
    }

	MSG_FUN_EXIT;
}
/*
static void set_lcd_backlight(struct led_classdev *led_dev, enum led_brightness value)
{
}
*/

boolean write_client_reg_TPO(uint32 reg_addr,uint8 *reg_Value, mddih_host_data_packet_size_type reg_packet_size, boolean wait)
{
	mddih_reg_write_type_uint8   reg_write;
	reg_write.addr  = reg_addr;
	reg_write.pValue = reg_Value;
	reg_write.packet_size = reg_packet_size;
	return(boolean) mddi_queue_multi_register_write_uint8(reg_write, wait, 0);
}

/*
static void auo_lcd_power_on_sequence(void)
{
}
*/
static void Renesas_lcd_power_on_sequence(void)
{
    uint32 RegPrm[20];
    int err = 0;
    cci_smem_value_t *smem_cci_smem_value = 0;

	MSG_FUN_ENTER;

    printk(KERN_INFO "[display] +%s.\n", __func__);

    memset(RegPrm,0,sizeof(RegPrm));

    msleep(10);//mdelay(10);
	gpio_direction_output(LCD_RST_N_113,0);//1 reset low
    msleep(5);//mdelay(5);
	gpio_direction_output(LCD_RST_N_113,1);//2 reset high
    msleep(1);//mdelay(1);

    msleep(15);//mdelay(15);

	RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    msleep(2);//mdelay(2);

	RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
	RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
	RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
	RegPrm[0] = 0x00;
    err = mddi_host_register_multiwrite(0x00ff, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    msleep(10);//mdelay(10);

    RegPrm[0] = 0x00;
    //Manufacturer Command Access Protect
    err = mddi_host_register_multiwrite(0x00b0, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0] = 0x02;
	RegPrm[1] = 0x00;
	RegPrm[2] = 0x00;
	RegPrm[3] = 0x00;
    //Frame Memory Access and Interface Setting
    err = mddi_host_register_multiwrite(0x00b3, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    //Display Mode amd Frame Memory Write Mode Setting
    err = mddi_host_register_multiwrite(0x00b4, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0] = 0x03;//13;
    RegPrm[1] = 0x3b;
    RegPrm[2] = 0x00;
    RegPrm[3] = 0x00;//02;
    RegPrm[4] = 0x00;
    RegPrm[5] = 0x01;
    RegPrm[6] = 0x00;//01;//00;
    RegPrm[7] = 0x43;
    //Panel Driving Setting
    err = mddi_host_register_multiwrite(0x00c0, RegPrm,8,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0] = 0x08;
	RegPrm[1] = 0x12;
    RegPrm[2] = 0x08;
    RegPrm[3] = 0x08;
    //Timing Setting for Normal Mode
    err = mddi_host_register_multiwrite(0x00c1, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0] = 0x11;//22;
	RegPrm[1] = 0x01;
    RegPrm[2] = 0x73;//00;//13;
    RegPrm[3] = 0x03;//01;
    //Source/VCOM/Gate Driving Timing Setting
    err = mddi_host_register_multiwrite(0x00c4, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
    /*
	RegPrm[0]  = 0x01;
	RegPrm[1]  = 0x0f;
	RegPrm[2]  = 0x0f;
	RegPrm[3]  = 0x3f;
	RegPrm[4]  = 0x3f;
	RegPrm[5]  = 0x36;
	RegPrm[6]  = 0x39;
	RegPrm[7]  = 0x08;
	RegPrm[8]  = 0x14;
    RegPrm[9]  = 0x90;
    RegPrm[10] = 0x90;
    RegPrm[11] = 0x37;
    RegPrm[12] = 0x5a;
    RegPrm[13] = 0x87;
    RegPrm[14] = 0xbe;
    RegPrm[15] = 0x00;
    RegPrm[16] = 0x00;
    RegPrm[17] = 0x03;
    //Backlight Conctrol 1
    err = mddi_host_register_multiwrite(0x00b8, RegPrm,18,TRUE,NULL,MDDI_HOST_PRIM);
	if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x01;
    RegPrm[1] = 0x00;
    RegPrm[2] = 0x07;
    RegPrm[3] = 0x08;
    //Backlight Control 2
    err = mddi_host_register_multiwrite(0x00b9, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
    */

	RegPrm[0]  = 0x02;//03;//05;
    RegPrm[1]  = 0x01;//08;//14;
    RegPrm[2]  = 0x0e;//06;//07;//0f;//0d;
    RegPrm[3]  = 0x46;//03;//46;//57;
    RegPrm[4]  = 0x04;//01;//02;//05;//03;
    RegPrm[5]  = 0x04;//01;//04;//0a;
    RegPrm[6]  = 0x1b;//13;//16;//18;
    RegPrm[7]  = 0x05;//03;//05;
    RegPrm[8]  = 0x13;//12;//13;//00;
    RegPrm[9]  = 0x31;//01;//31;//32;
    RegPrm[10] = 0x05;//03;//05;
    RegPrm[11] = 0x1b;//12;//13;//16;//18;
    RegPrm[12] = 0x04;//01;//04;//0a;
    RegPrm[13] = 0x44;//01;//02;//45;//53;
    RegPrm[14] = 0x06;//03;//06;//07;
    RegPrm[15] = 0x0e;//06;//07;//0f;//0d;
    RegPrm[16] = 0x01;//08;//14;
    RegPrm[17] = 0x02;//03;//05;
    RegPrm[18] = 0x31;//01;//31;//32;
    RegPrm[19] = 0x13;//00;
    //Gamma Set
    err = mddi_host_register_multiwrite(0x00c8, RegPrm,20,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    RegPrm[1] = 0x00;
    RegPrm[2] = 0x01;
    RegPrm[3] = 0x3f;
    //Set Column Address
    err = mddi_host_register_multiwrite(0x002a, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0] = 0x00;
    RegPrm[1] = 0x00;
    RegPrm[2] = 0x01;
    RegPrm[3] = 0xdf;
    //Set Page Address
    err = mddi_host_register_multiwrite(0x002b, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    //Set Tear On
    err = mddi_host_register_multiwrite(0x0035, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x06;//18bpp //07;//24bpp
    //Set Pixel Format
    err  = mddi_host_register_multiwrite(0x003a, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    RegPrm[1] = 0x01;
    //Set Tear Scanline
    err = mddi_host_register_multiwrite(0x0044, RegPrm,2,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    RegPrm[1] = 0x00;
    RegPrm[2] = 0x00;
    RegPrm[3] = 0xc0;
    RegPrm[4] = 0xb0;
    RegPrm[5] = 0x00;
    err = mddi_host_register_multiwrite(0x00fe, RegPrm,6,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    smem_cci_smem_value = smem_alloc( SMEM_CCI_SMEM_VALUE, sizeof( cci_smem_value_t ) );
    switch(smem_cci_smem_value->cci_hw_id)
    {
        case HW_ID_PVT:
            RegPrm[0] = 0x00;
            //Exit Sleep Mode
            err = mddi_host_register_multiwrite(0x0011, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            msleep(150);//mdelay(150);

            RegPrm[0] = 0x00;
            //Write Memory Start
            err = mddi_host_register_multiwrite(0x002c, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = 0x07;
            RegPrm[1] = 0x07;//01;
            RegPrm[2] = 0x1e;//15;
            RegPrm[3] = 0x66;//62;//02;
            //Power Setting (Common Setting)
            err = mddi_host_register_multiwrite(0x00d0, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = 0x03;
            RegPrm[1] = 0x5d;//61;//62;
            RegPrm[2] = 0x0d;//10;
            //Vcom Setting
            err = mddi_host_register_multiwrite(0x00d1, RegPrm,3,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = 0x03;
            RegPrm[1] = 0x04;//00;//24;
            RegPrm[2] = 0x04;//00;
            //Power Setting for Normal Mode
            err = mddi_host_register_multiwrite(0x00d2, RegPrm,3,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            msleep(10);//mdelay(10);

            RegPrm[0] = 0x00;
            //Set Display On
            err = mddi_host_register_multiwrite(0x0029, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            break;
        case HW_ID_PVT2:
        default:
            RegPrm[0] = 0x07;
            RegPrm[1] = 0x07;//01;
            RegPrm[2] = 0x1e;//15;
            RegPrm[3] = 0x66;//62;//02;
            //Power Setting (Common Setting)
            err = mddi_host_register_multiwrite(0x00d0, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            //  RegPrm[0] = 0x03;
            //  RegPrm[1] = 0x61;//62;
            //  RegPrm[2] = 0x10;
            //Vcom Setting
            //  err = mddi_host_register_multiwrite(0x00d1, RegPrm,3,TRUE,NULL,MDDI_HOST_PRIM);
            //  if(err)
            //      printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = 0x03;
            RegPrm[1] = 0x04;//00;//24;
            RegPrm[2] = 0x04;//00;
            //Power Setting for Normal Mode
            err = mddi_host_register_multiwrite(0x00d2, RegPrm,3,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            msleep(10);//mdelay(10);

            RegPrm[0] = 0x00;
            //Exit Sleep Mode
            err = mddi_host_register_multiwrite(0x0011, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            msleep(150);//mdelay(150);

            RegPrm[0] = 0x00;
            //Set Display On
            err = mddi_host_register_multiwrite(0x0029, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

            RegPrm[0] = 0x00;
            //Write Memory Start
            err = mddi_host_register_multiwrite(0x002c, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            break;
    }

    MSG_FUN_EXIT;
}

static void Renesas_lcd_power_on_sequence_part(void)
{
    uint32 RegPrm[1];
    int err = 0;
    memset(RegPrm,0,sizeof(RegPrm));
    RegPrm[0] = 0x06;//18bpp //07;//24bpp
    //Set Pixel Format
    err  = mddi_host_register_multiwrite(0x003a, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
}

static void Ilitek_lcd_power_on_sequence(void)
{
    uint32 RegPrm[16];
    int err = 0;

    MSG_FUN_ENTER;

    printk(KERN_INFO "[display] +%s.\n", __func__);

    memset(RegPrm,0,sizeof(RegPrm));

    msleep(10);//mdelay(10);
    gpio_direction_output(LCD_RST_N_113,0);//1 reset low
    msleep(1);//mdelay(1);
    gpio_direction_output(LCD_RST_N_113,1);//2 reset high
    msleep(120);//mdelay(120);

    RegPrm[0]   = 0x0f;
    RegPrm[1]   = 0x10;
    RegPrm[2]   = 0x08;
    RegPrm[3]   = 0x05;
    RegPrm[4]   = 0x09;
    RegPrm[5]   = 0x05;
    RegPrm[6]   = 0x37;
    RegPrm[7]   = 0x98;
    RegPrm[8]   = 0x26;
    RegPrm[9]   = 0x07;
    RegPrm[10]  = 0x0f;
    RegPrm[11]  = 0x02;
    RegPrm[12]  = 0x09;
    RegPrm[13]  = 0x07;
    RegPrm[14]  = 0x00;//1
    //Positive Gamma Control
    err = mddi_host_register_multiwrite(0x00e0, RegPrm,15,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0]  = 0x0f;
    RegPrm[1]  = 0x38;
    RegPrm[2]  = 0x36;
    RegPrm[3]  = 0x0d;
    RegPrm[4]  = 0x10;
    RegPrm[5]  = 0x08;
    RegPrm[6]  = 0x59;
    RegPrm[7]  = 0x76;
    RegPrm[8]  = 0x48;
    RegPrm[9]  = 0x0a;
    RegPrm[10] = 0x16;
    RegPrm[11] = 0x0a;
    RegPrm[12] = 0x37;
    RegPrm[13] = 0x2f;
    RegPrm[14] = 0x00;//2
    //Negative Gamma Control
    err = mddi_host_register_multiwrite(0x00e1, RegPrm,15,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0xf6;
    //solution for display resume fail
    err = mddi_host_register_multiwrite(0x00f1, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x21;
    RegPrm[1] = 0x04;//3
    err = mddi_host_register_multiwrite(0x00f8, RegPrm,2,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0xc0;  //81HZ
    RegPrm[1] = 0x11;//4
    //Frame Rate Control
    err = mddi_host_register_multiwrite(0x00b1, RegPrm,2,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x02;
    RegPrm[1] = 0x22;// 5
    //Display Function Control
    err = mddi_host_register_multiwrite(0x00b6, RegPrm,2,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    RegPrm[1] = 0x58;//6
    //VCOM Control
    err = mddi_host_register_multiwrite(0x00c5, RegPrm,2,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x08;//7
    //Memory Access Control
    err = mddi_host_register_multiwrite(0x0036, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x18;
    RegPrm[1] = 0xa3;
    RegPrm[2] = 0x12;
    RegPrm[3] = 0x02;
    RegPrm[4] = 0xb2;
    RegPrm[5] = 0x12;
    RegPrm[6] = 0xff;
    RegPrm[7] = 0x12;
    //RegPrm[8] = 0x00; //8
    err = mddi_host_register_multiwrite(0x00f2, RegPrm,8,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x02;//9
    //Display Inversion Control
    err = mddi_host_register_multiwrite(0x00b4, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;//10
    //Display Inversion ON
    err = mddi_host_register_multiwrite(0x0021, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    //added by steve@cci for bug537
    RegPrm[0] = 0x08;
    //adjust pwm frequency
    err = mddi_host_register_multiwrite(0x00cf, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;//11
    //Sleep OUT
    err = mddi_host_register_multiwrite(0x0011, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    msleep(120);//mdelay(120);    // Delay 120ms

    RegPrm[0] = 0x00;//12
    //Display ON
    err = mddi_host_register_multiwrite(0x0029, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;//13
    //Memory Write
    err  = mddi_host_register_multiwrite(0x002c, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    RegPrm[0] = 0x00;
    //Tearing Effect Line On
    err  = mddi_host_register_multiwrite(0x0035, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    //added by steve@cci for CABC test
    //RegPrm[0] = 0x03;
    //mddi_host_register_multiwrite(0x0055, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);

    MSG_FUN_EXIT;
}

static void lcd_power_off_sequence(void)
{
	//Ilitek and Renesas are all in here.
    int rc;
	struct vreg *vreg_rfrx2 = NULL;
	struct vreg *vreg_gp5 = NULL;
    int  err = 0;
	uint32 RegPrm[2];
    cci_smem_value_t *smem_cci_smem_value = 0;

    MSG_FUN_ENTER;

    printk(KERN_INFO "[display] +%s.\n", __func__);

    smem_cci_smem_value = smem_alloc( SMEM_CCI_SMEM_VALUE, sizeof( cci_smem_value_t ) );
    switch(smem_cci_smem_value->cci_hw_id)
    {
        case HW_ID_EVT0:
        case HW_ID_DVT1:
        case HW_ID_DVT1_2:
        case HW_ID_DVT2:
        case HW_ID_DVT2_2:
            RegPrm[0]    = 0x00;
            err = mddi_host_register_multiwrite(0x0053, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
            if(err)
                printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            break;
        case HW_ID_PVT:
        default:
            if(!gpio_get_value(LCD_2nd_SOURCE))
            {
                RegPrm[0]    = 0x00;
                err = mddi_host_register_multiwrite(0x0053, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
                if(err)
                    printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);
            }
            break;
    }

	RegPrm[0]	 = 0x00;
    //Set Display Off
    err = mddi_host_register_multiwrite(0x0028, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

	RegPrm[0]	 = 0x00;
    //Enter Sleep Mode
    err = mddi_host_register_multiwrite(0x0010, RegPrm,1,TRUE,NULL,MDDI_HOST_PRIM);
    if(err)
        printk(KERN_ERR"%d : mddi_host_register_multiwrite error\n", __LINE__);

    msleep(120);//mdelay(120);

	gpio_direction_output(LCD_RST_N_113, 0);//reset low

	vreg_rfrx2 = vreg_get(0, "rfrx2");	
	rc = vreg_disable(vreg_rfrx2);
	if (rc)
	{
		printk("%s: vreg enable rfrx2 failed (%d)\r\n", __func__, rc);
	}

	vreg_gp5 = vreg_get(0, "gp5");
	rc = vreg_disable(vreg_gp5);
	if (rc)
	{
		printk("%s: vreg enable gp5 failed (%d)\r\n", __func__, rc);
	}

    update = FALSE;

	MSG_FUN_EXIT;

}

static void lcd_power_on_init(void)
{
	int rc;
	struct vreg *vreg_rfrx2 = NULL;
	struct vreg *vreg_gp5 = NULL;

    MSG_DBG("[display] +%s.\n". __func__);

    vreg_gp5 = vreg_get(0, "gp5");

    rc = vreg_set_level(vreg_gp5, 1800);
	if (rc) 
	{
		printk(KERN_INFO "%s: vreg set gp5 level failed (%d)\r\n",	__func__, rc);
	}

	rc = vreg_enable(vreg_gp5);
	if (rc) 
	{
        printk("%s: vreg enable gp5 failed (%d)\r\n", __func__, rc);
	}

	vreg_rfrx2 = vreg_get(0, "rfrx2");

	rc = vreg_set_level(vreg_rfrx2, 2800);
	if (rc) 
	{
		printk(KERN_INFO "%s: vreg set rfrx2 level failed (%d)\r\n", __func__, rc);
	}

	rc = vreg_enable(vreg_rfrx2);
	if (rc) 
	{
        printk("%s: vreg enable gp2 failed (%d)\r\n", __func__, rc);
	}
}

static void mddi_cci_ab60_power_on_sequence(void)
{
	cci_smem_value_t *smem_cci_smem_value = 0;

    MSG_FUN_ENTER;

    smem_cci_smem_value = smem_alloc( SMEM_CCI_SMEM_VALUE, sizeof( cci_smem_value_t ) );
    switch(smem_cci_smem_value->cci_hw_id)
    {
        case HW_ID_EVT0:
        case HW_ID_DVT1:
        case HW_ID_DVT1_2:
        case HW_ID_DVT2:
        case HW_ID_DVT2_2:
            Ilitek_lcd_power_on_sequence();
            break;
        case HW_ID_PVT:
        default:
            if(gpio_get_value(LCD_2nd_SOURCE))
                Renesas_lcd_power_on_sequence();
            else
                Ilitek_lcd_power_on_sequence();
            break;
    }
    first_backlight = TRUE;
/*
	switch( g_lcd_type )
	{
		case LCD_TYPE_TPO:
			//MSG_DBG("John mddi_cci_ab60_power_on_sequence LCD_TYPE_TPO\r\n");
			tpo_lcd_power_on_sequence();
			backlight_on(TRUE);
			break;
		case LCD_TYPE_AUO:
			//MSG_DBG("John mddi_cci_ab60_power_on_sequence LCD_TYPE_AUO\r\n");
			auo_lcd_power_on_sequence();
			backlight_on(TRUE);
			break;	
		default:
			MSG_ERR("LCD type: INVALID!\n");
			break;
	}
*/	
	//backlight_on(TRUE);

	MSG_FUN_EXIT;
}

#if 1
static void mddi_cci_ab60_lcd_set_backlight(struct msm_fb_data_type *mfd)
{
	//unsigned char transform_val;

	MSG_FUN_ENTER;

	//MSG_DBG("########  mfd->bl_level = %d ############## \n", mfd->bl_level);
#if 0
	transform_val = blk_value_transform((unsigned char)mfd->bl_level);
	backlight_val = 0xFF - transform_val;
	//MSG_DBG(" mfd->bl_level=%d, transform_val=%d, backlight_val=%d ############## \n", mfd->bl_level, transform_val, backlight_val);
	mddi_cci_ab60_set_backlight_level(backlight_val);
#else
	mddi_cci_ab60_set_backlight_level(mfd->bl_level);
#endif
/*	
	backlight_val =255 - (mfd->bl_level & 0xFF);
	mddi_cci_ab60_set_backlight_level(backlight_val);
*/	

	MSG_FUN_EXIT;	
}
#else

static DEFINE_MUTEX(key_light_mutex);
static void mddi_cci_ab60_lcd_set_backlight(struct msm_fb_data_type *mfd)
{
	int32 level=0x0;
        //CB60_SCR_4644 SOF
        u8 buf[10];
        //unsigned i = 0;

	MSG_FUN_ENTER;

	memset(buf, 0X0, sizeof(buf));
        //CB60_SCR_4644 EOF
	MSG_DBG("######## Config LCM_BL_EN GPIO 91 level = %d ############## \n", mfd->bl_level);

	level = mfd->bl_level;

	//james@cci added for backlight control
	if(level == 7 ) {
		backlight_on(TRUE);
		//MSG_DBG("%s LCD_BLK_EN = %d\n",__func__,gpio_get_value(LCD_BLK_EN));
		MSG_DBG("do backlighton\n");
	}
	//james@cci added for backlight control
	if(level == 0) {//change to 1
		backlight_on(FALSE);
		//MSG_DBG("%s LCD_BLK_EN = %d\n",__func__,gpio_get_value(LCD_BLK_EN));
                //CB60_SCR_4644 SOF
mutex_lock(&key_light_mutex);
#if 0
                //del_timer(&keylight_timer);
		i = 0;
		hrtimer_cancel(&led_timer);
	        do{
                buf[i] = wled_off[i];
		buf[i] = LED_CURRENT_STATE[i];
                i++;
               }while(i<10);
               i2c_master_send(TCA6507_i2c_client, buf, 10);  
		keylight_flag = 0 ;
#endif
mutex_unlock(&key_light_mutex);
                //CB60_SCR_4644 EOF
		MSG_DBG("do backlightoff\n");
	}

	MSG_FUN_EXIT;
}

#endif

static void mddi_cci_ab60_prim_lcd_init(void)
{
    cci_smem_value_t *smem_cci_smem_value = 0;

    MSG_FUN_ENTER;

    printk(KERN_INFO "[display] +%s.\n", __func__);
	lcd_power_on_init();
	if( !LCD_powered )
	{
		MSG_DBG("[display]mddi_cci_ab60_prim_lcd_init 1\r\n");
		mddi_cci_ab60_power_on_sequence();
		msleep(5);//mdelay(5);
		LCD_powered = TRUE;
        if(blk_value_before_display_on)//added by steve@cci for Bug341
        {
            mddi_cci_ab60_set_backlight_level(blk_value_before_display_on);
            blk_value_before_display_on = 0;
        }
	}
	else
	{
		MSG_DBG("John mddi_cci_ab60_prim_lcd_init 2\r\n");
		if (First_bootup)
		{
            smem_cci_smem_value = smem_alloc( SMEM_CCI_SMEM_VALUE, sizeof( cci_smem_value_t ) );
            switch(smem_cci_smem_value->cci_hw_id)
            {
                case HW_ID_EVT0:
                case HW_ID_DVT1:
                case HW_ID_DVT1_2:
                case HW_ID_DVT2:
                case HW_ID_DVT2_2:
                    break;
                case HW_ID_PVT:
                default:
                    if(gpio_get_value(LCD_2nd_SOURCE))
                        Renesas_lcd_power_on_sequence_part();
                    break;
            }
		}
		First_bootup = FALSE;
 	}

	/* Set the MDP pixel data attributes for Primary Display */
	mddi_host_write_pix_attr_reg(MDDI_DEFAULT_PRIM_PIX_ATTR);  	

	MSG_FUN_EXIT;
}

static int mddi_cci_ab60_lcd_on(struct platform_device *pdev)
{
	struct msm_fb_data_type *mfd;
	MSG_FUN_ENTER;
	//BKL_EN=1;
    printk(KERN_INFO "[display] +%s.\n", __func__);
	mfd = platform_get_drvdata(pdev);
	if (!mfd)
	{
		MSG_ERR("mfd is NULL.\r\n");
		MSG_FUN_EXIT;
		return -ENODEV;
	}

	if (mfd->key != MFD_KEY)
	{
		MSG_ERR("mfd->key != MFD_KEY.\r\n");
		MSG_FUN_EXIT;		
		return -EINVAL;
	}

	if (mfd->panel.id == CCI_AB60_HVGA_PRIM)
    {
		mddi_cci_ab60_prim_lcd_init();
    }
	else
	{
		MSG_ERR(KERN_ALERT "%s:%d --> Unknown LCD Panel id = %d, return -EINVAL\r\n", __func__, __LINE__, mfd->panel.id);
		return -EINVAL;
	}

	MSG_FUN_EXIT;	

	return 0;
}

static int mddi_cci_ab60_lcd_off(struct platform_device *pdev)
{
	MSG_FUN_ENTER;
    printk(KERN_INFO "[display] +%s.\n", __func__);
	LCD_powered = FALSE;
	//BKL_EN=0;
	/*
	switch( g_lcd_type )
	{
		case LCD_TYPE_TPO:
			backlight_on(FALSE);
			tpo_lcd_power_off_sequence();
			break;
		case LCD_TYPE_AUO:
			backlight_on(FALSE);
			auo_lcd_power_off_sequence();
			break;	
		default:
			MSG_ERR("LCD type: INVALID!\r\n");
			break;
	}
	*/
	//backlight_on(FALSE);//no enable gpio pin in C6
	lcd_power_off_sequence();
  
	//disable_hibernation_proc(FALSE);

	MSG_FUN_EXIT;
	return 0;
}
/*
static E_LCD_TYPE get_lcd_type(void)
{
#if 0
	int lcd_id;
	E_LCD_TYPE lcd_type;
	
	gpio_direction_input(LCD_ID0);
	lcd_id = gpio_get_value(LCD_ID0);
	
	switch(lcd_id)
	{

		case 0:
			lcd_type = LCD_TYPE_AUO;
			break;
		case 1:
			lcd_type = LCD_TYPE_TPO;
			break;				
		default:
			lcd_type = LCD_TYPE_INVALID;
			break;
	}
	return lcd_type;
#else
	return LCD_TYPE_TPO;
#endif
}
*/
static int __devinit mddi_cci_ab60_probe(struct platform_device *pdev)
{
	MSG_FUN_ENTER;

	if (pdev->id == 0) {
		MSG_DBG("%s id == 0\r\n", __func__);
		mddi_cci_ab60_pdata = pdev->dev.platform_data;
		return 0;
	}	

//	g_lcd_type = get_lcd_type();

	//MSG_DBG("%s g_lcd_type=%d\r\n", __func__, g_lcd_type);
	//panel_type_number = (int)g_lcd_type;
	
	msm_fb_add_device(pdev);

	MSG_FUN_EXIT;
	return 0;
}

static int mddi_cci_ab60_suspend(struct platform_device *pdev, pm_message_t state)
{
	
	return 0;
}
/*
static int mddi_cci_ab60_early_suspend(struct platform_device *pdev)
{
	//printk("[Aaron][%s]\r\n", __func__);

	return 0;
}

static int mddi_cci_ab60_later_resume(struct platform_device *pdev)
{
	//printk("[Aaron][%s]\r\n", __func__);

	return 0;
}
*/
static int mddi_cci_ab60_resume(struct platform_device *pdev)
{
	//printk("[Aaron][%s]\r\n", __func__);

	
	return 0;
}
/*
static struct led_classdev lcd_backlight = {
	.name = "bkl",
	.brightness_set = set_lcd_backlight,
	.default_trigger = "charger",
};
*/

static struct platform_driver this_mddi_driver = {
	.probe  = mddi_cci_ab60_probe,
	.suspend = mddi_cci_ab60_suspend,
	.resume = mddi_cci_ab60_resume,
	.driver = {
		.name   = "mddi_cci_ab60_wvga",
	},
};

static struct msm_fb_panel_data mddi_cci_ab60_panel_data = {
	.on = mddi_cci_ab60_lcd_on,
	.off = mddi_cci_ab60_lcd_off,
	.set_backlight = mddi_cci_ab60_lcd_set_backlight,
	.set_vsync_notifier = NULL,
};

static struct platform_device this_mddi_device = {
	.name   = "mddi_cci_ab60_wvga",
	.id	= CCI_AB60_HVGA_PRIM,
	.dev	= {
		.platform_data = &mddi_cci_ab60_panel_data,
	}
};

static int __init mddi_cci_ab60_init(void)
{
	int ret;
	struct msm_panel_info *pinfo;

/*#ifdef CONFIG_FB_MSM_MDDI_AUTO_DETECT
	u32 id;
	id = mddi_get_client_id();

	if (((id >> 16) != 0x0) || ((id & 0xffff) != 0x8835))
		return 0;
#endif*/
	MSG_FUN_ENTER;

	if (gpio_request(LCD_RST_N_113, "lcd_rst_n_113"))
        MSG_ERR("failed to request gpio lcd_rst_n_113\n");
    //gpio_tlmm_config(GPIO_CFG(LCD_RST_N_113, 1, GPIO_CFG_OUTPUT, GPIO_CFG_NO_PULL, GPIO_CFG_8MA),GPIO_CFG_ENABLE);
				
	if (mddi_host_core_version > 8) {
		/* can use faster refresh with newer hw revisions */
		mddi_cci_ab60_debug_60hz_refresh = TRUE;

		/* Timing variables for tracking vsync */
		/* dot_clock = 6.00MHz
		 * horizontal count = 296
		 * vertical count = 338
		 * refresh rate = 6000000/(296+338) = 60Hz
		 */
		mddi_cci_ab60_rows_per_second = 20270;	/* 6000000/296 */
		mddi_cci_ab60_rows_per_refresh = 338;
		mddi_cci_ab60_usecs_per_refresh = 16674;	/* (296+338)/6000000 */
		MSG_DBG("##### %s mddi_host_core_version > 8 #####\n",__func__);
	} else {
		/* Timing variables for tracking vsync */
		/* dot_clock = 5.20MHz
		 * horizontal count = 376
		 * vertical count = 338
		 * refresh rate = 5200000/(376+338) = 41Hz
		 */
		mddi_cci_ab60_rows_per_second = 13830;	/* 5200000/376 */
		mddi_cci_ab60_rows_per_refresh = 338;
		mddi_cci_ab60_usecs_per_refresh = 24440;	/* (376+338)/5200000 */

	}
	ret = platform_driver_register(&this_mddi_driver);
	if (ret)
	{
		MSG_ERR("platform_driver_register return fail.\n");
		MSG_FUN_EXIT;
		return ret;
	}

	pinfo = &mddi_cci_ab60_panel_data.panel_info;
	pinfo->xres = 320;
	pinfo->yres = 480;
	pinfo->type = MDDI_PANEL;
	pinfo->pdest = DISPLAY_1;
	pinfo->mddi.vdopkt = MDDI_DEFAULT_PRIM_PIX_ATTR;
	pinfo->wait_cycle = 0;
	pinfo->bpp = 18;
	pinfo->fb_num = 2;
	pinfo->clk_rate =    81920000;
	pinfo->clk_min =     80000000;
	pinfo->clk_max =    100000000;
	pinfo->lcd.vsync_enable = TRUE;
	pinfo->lcd.refx100 =
		(mddi_cci_ab60_rows_per_second * 100) / mddi_cci_ab60_rows_per_refresh;
	pinfo->lcd.v_back_porch = 18;
	pinfo->lcd.v_front_porch = 18;
	pinfo->lcd.v_pulse_width = 0;
	pinfo->lcd.hw_vsync_mode = TRUE;
	pinfo->lcd.vsync_notifier_period = 0;//(1 * HZ);
	pinfo->bl_max = 255;
	pinfo->bl_min = 0;

	ret = platform_device_register(&this_mddi_device);
	if (ret)
		platform_driver_unregister(&this_mddi_driver);

	//led_classdev_register(NULL, &lcd_backlight);
	//mddi_early.level = EARLY_SUSPEND_LEVEL_DISABLE_FB;
	//mddi_early.suspend = mddi_cci_ab60_early_suspend;
	//mddi_early.resume = mddi_cci_ab60_later_resume;
	//register_early_suspend(&mddi_early);

	MSG_FUN_EXIT;
	return ret;
}
#endif // CONFIG_FB_MSM_MDDI

//added by steve@cci for acer CR tuning
static int proc_lcm_CR_read(char *page, char**start, off_t offset,
                          int count, int *eof, void *data)
{
    return 0;
}

static int proc_lcm_CR_write(struct file *file, const char *buffer,
                           unsigned long count, void *data)
{
    int ret = 0;
    uint8 CR_value = 0;
    uint32 RegPrm[16];
    char bufstr[64], *endp;

    if(!LCD_powered)
        return 0;

    memset(RegPrm,0,sizeof(RegPrm));
    printk ("*** %s ***\n", __func__);

    bufstr[0] = '\0';
    ret = copy_from_user(&bufstr, buffer, (sizeof(bufstr)-1));

    if (ret) {
        printk(KERN_ERR "%s:%s():%d --> Fail to copy_from_user()\n", __FILE__, __func__, __LINE__);
        goto end;
    }

    if (count < sizeof(bufstr))
        bufstr[count] = '\0';
    else
        bufstr[sizeof(bufstr)-1] = '\0';

    CR_value = (uint8)simple_strtol(bufstr, &endp, 0);
    printk("CR value = %d\n",CR_value);

    if(CR_value > 128)
        CR_value = 128;
    else if(CR_value <= 0)
        CR_value = 0;
    else
        CR_value = CR_value;

    RegPrm[0] = 0x01;
    RegPrm[1] = CR_value;
    RegPrm[2] = 0x80;
    RegPrm[3] = 0x00;
    mddi_host_register_multiwrite(0x00c5, RegPrm,4,TRUE,NULL,MDDI_HOST_PRIM);

end:

    return count;
}

//added by steve@cci for acer CR tuning
static int init_proc(void)
{
    int retval = 0;

    struct proc_dir_entry *lcmCR_proc_enable = NULL;
    /* Create /proc/lcmCR */
    if( !(lcmCR_proc_dir = proc_mkdir("lcmCR", &proc_root)) )
    {
        printk(KERN_ERR "%s:%s():%d --> Cannot create /proc/lcmCR\n", __FILE__, __func__, __LINE__);
        retval = -1;
        goto end;
    }
    else
    {
        //vibrator_proc_dir->owner = THIS_MODULE;
    }
    /* create enable entry */
    if( !(lcmCR_proc_enable = create_proc_entry("CRvalue", 0666, lcmCR_proc_dir)) ) //file name, privilege, parent
    {
        printk(KERN_ERR "%s:%s():%d --> Cannot create /proc/lcmCR/CRvalue\n", __FILE__, __func__, __LINE__);
        retval = -1;
        goto end;
    }
    else
    {
        lcmCR_proc_enable->read_proc = proc_lcm_CR_read;
        lcmCR_proc_enable->write_proc = proc_lcm_CR_write;
    }

    return retval;

end:
    return retval;
}

static int __init mddi_lcdc_cci_init(void)
{
	int ret = 0;
    ret = init_proc();
    if(ret)
        printk(KERN_ERR "[STEVE] init_proc error!");

    ret = mddi_cci_ab60_init();
	printk(KERN_INFO "[John] mddi_lcdc_cci_init: MDDI test2 ret=%d\r\n", ret);
	return ret;
}

module_init(mddi_lcdc_cci_init);
